// This file is part of the PiDuce project (http://www.cs.unibo.it/Piduce/)
// developed at the Department of Computer Science of Bologna.
// Authors: Samuele Carpineti, Cosimo Laneve, Luca Padovani
//
// See Copyright for the status of this software.

namespace PiDuce.Common
{
  public class Cell<T>
  {
    private T content;
    private Cell<T> next;

    public Cell(T content, Cell<T> next)
    {
      this.content = content;
      this.next = next;
    }

    public T Content { get { return this.content; } }
    public Cell<T> Next { get { return this.next; } }

    public static bool Contains(Cell<T> p, T content)
    {
      while (p != null) {
        if (p.content.Equals(content))
          return true;
        p = p.Next;
      }
      return false;
    }

    public bool Contains(T content)
    { return Contains(this, content); }

    public Cell<T> Prepend(T content)
    { return new Cell<T>(content, this); }
  }
}
