// This file is part of the PiDuce project (http://www.cs.unibo.it/Piduce/)
// developed at the Department of Computer Science of Bologna.
// Authors: Samuele Carpineti, Cosimo Laneve, Luca Padovani
//
// See Copyright for the status of this software.

using PiDuce.Common;
using System.Collections.Generic;

namespace PiDuce.Machine
{
	public class SchemaEntry : AbstractEntry
	{
		public SchemaEntry(string name, ISchema schema)
			: base(name, schema)
		{ }
	}

	public class ValueEntry : AbstractEntry
	{
		private readonly int index;

		public int Index { get { return index; } }

		public ValueEntry(string name, ISchema schema, int index)
			: base(name, schema)
		{ this.index = index; }
	}

  public class SchemaSymbolTable : SymbolTable<SchemaEntry>
  {
    public SchemaEntry New(string name, ISchema schema)
    { return new SchemaEntry(name, schema); }
  }
}

