// This file is part of the PiDuce project (http://www.cs.unibo.it/Piduce/)
// developed at the Department of Computer Science of Bologna.
// Authors: Samuele Carpineti, Cosimo Laneve, Luca Padovani
//
// See Copyright for the status of this software.

using System.Collections.Generic;
using System.Diagnostics;
using PiDuce.Common;

namespace PiDuce.Machine
{
	public class TypeMap
	{
		private readonly IDictionary<string, TypeRef> map = new Dictionary<string, TypeRef>();

		public TypeRef New(string name, IType type)
		{
			TypeRef r = new TypeRef(name, type);
			map.Add(name, r);
			return r;
		}

		public TypeRef Lookup(string name)
		{
			Debug.Assert(map.ContainsKey(name));
			return map[name];
		}
	}
}

